# $Id: ncp.pac 1327 2005-09-07 17:34:57Z vern $
#
# Netware Core Protocol

type ncp_request(length) = record {
	let function 	= length > 0 ? data[0] : 0;
	let subfunction	= length > 1 ? data[1] : 0;
	data		: uint8[length];
};

type ncp_reply(length) = record {
	completion_code	: uint8;
	conn_status 	: uint8;
	data		: uint8[length - 2];
};

type ncp_frame(is_orig, length) = record {
	frame_type	: uint16;
	seq		: uint8;
	conn_low	: uint8;
	task		: uint8;
	conn_high	: uint8;

	let body_length = length - offsetof(body);
	body		: case is_orig of
		{
		1 => request	: ncp_request(body_length);
		0 => reply	: ncp_reply(body_length);
		};
};

type ncp_over_tcpip_req_hdr = record {
	version		: uint32;
	reply_buf_size	: uint32;
};

type ncp_over_tcpip_frame(is_orig) = record {
	signature	: uint32;
	length		: uint32;
	aux		: case is_orig of
		{
		1 => aux_req	: ncp_over_tcpip_req_hdr;
		0 => aux_reply	: empty;
		};
	ncp		: ncp_frame(is_orig, length - offsetof(ncp));
} 	&byteorder = bigendian,
	&length = length,
	&check( ncp.frame_type == 0x1111 ||
		ncp.frame_type == 0x2222 ||
		ncp.frame_type == 0x3333 ||
		ncp.frame_type == 0x5555 ||
		ncp.frame_type == 0x7777 ||
		ncp.frame_type == 0x9999 );
